/*
bttravsk.c Version 0.2.0  Btree change position in
database during traverse
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

off_t bttravsk(bthdr,ofst)
btreefmt *bthdr;
off_t ofst;
   {
   off_t loc;
   bthdr->reason = 0;
   loc = lseek(bthdr->hndl,ofst,SEEK_SET);
   if (loc < 0)
      {
      fprintf(stderr,"bttravsk: Lseek error "
	 "(hndl %d ofst %08x)\n",
	 bthdr->hndl,
	 (unsigned int) ofst);
      perror("bttravsk: Lseek error");
      bthdr->reason = SYS_ERR + errno;
      return(loc);
      } /* lseek err */
   else if (loc != ofst)
      {
      fprintf(stderr,"bttravsk: Lseek error "
	 "(hndl %d ofst %08x loc %08x)\n",
	 bthdr->hndl,
	 (unsigned int) ofst,
	 (unsigned int) loc);
      bthdr->reason = BTREE_ERR + 701;
      return(-bthdr->reason);
      } /* lseek err */
   return(loc);
   } /* bttravsk */
